Esportare calendario e contatti da Google e Microsoft
Modulo 5: Agenda e contatti · Tempo di lettura: 12 minuti
Obiettivo della lezione: dopo questa lezione sarà in grado di creare un'esportazione completa e utilizzabile di calendari e contatti da Google e Microsoft, di leggere un file ICS e vCard, e saprà cosa non viene incluso o viene trattato diversamente durante l'esportazione.
Concetti chiave: iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE e TZID, ORGANIZER e ATTENDEE, VALARM, vCard (VCF) 3.0 e 4.0, csv, Google Takeout, strumento di migrazione
Due formati di file che quasi tutti conoscono
Calendari e contatti si trasferiscono con due formati aperti:
- iCalendar, file con estensione
.ics(RFC 5545), per calendari e attività. - vCard, file con estensione
.vcf, per i contatti. Esistono due versioni che potrà incontrare: 3.0 (RFC 2426) e 4.0 (RFC 6350).
Sono normali file di testo. Può aprirli in un editor di testo, ed è esattamente quello che farà in questa lezione. Chi sa cosa contengono, vede anche cosa manca.
Spesso esiste una strada più semplice dell'esportazione manuale: molti nuovi servizi dispongono di uno strumento di migrazione che, con il Suo consenso, recupera direttamente da Google o Microsoft i Suoi calendari e contatti. È più rapido e con meno errori. Tuttavia un'esportazione propria resta consigliabile: come controllo (quanti appuntamenti e contatti avevo?), come backup prima di disdire il vecchio servizio, e come via d'uscita se lo strumento di migrazione non è consentito dal Suo amministratore.
Com'è fatto un file di calendario
Un'esportazione del calendario di Bakkerij De Korrel inizia così:
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARCosa vede:
| Riga | Significato | Dove può andare storto |
|---|---|---|
BEGIN:VCALENDAR e VERSION:2.0 | indica che si tratta di un file iCalendar | se manca, l'importazione viene rifiutata |
BEGIN:VEVENT ... END:VEVENT | un appuntamento | un END mancante rende illeggibile il resto |
UID | l'identificativo fisso dell'appuntamento | senza UID il server non riesce a riconoscere i duplicati |
DTSTART;TZID=... | orario di inizio in un fuso orario | vedi fusi orari più sotto |
RRULE | regola di ricorrenza: ogni martedì | una regola non valida produce un solo appuntamento invece di una serie |
EXDATE | eccezione: questo martedì no | |
ORGANIZER, ATTENDEE | chi ha invitato e chi è invitato | vedi inviti più sotto |
VALARM | promemoria, 30 minuti prima | non tutti i servizi recepiscono i promemoria |
Fusi orari
Un orario con TZID=Europe/Amsterdam significa: le 6 del mattino ad Amsterdam, anche dopo il passaggio all'ora legale. Il file dovrebbe quindi contenere un blocco VTIMEZONE che descrive quel fuso orario. Le esportazioni da Outlook usano spesso nomi Windows come W. Europe Standard Time. Funziona correttamente finché il blocco VTIMEZONE è presente. Se manca, il nuovo servizio deve indovinare, e gli appuntamenti risultano spostati di un'ora. Un orario che termina con Z (20261110T050000Z) è in UTC ed è sempre univoco. Un orario senza fuso orario e senza Z è detto orario "fluttuante": vale nel fuso orario di chi lo visualizza.
Gli appuntamenti per l'intera giornata sono indicati come data senza orario: DTSTART;VALUE=DATE:20261224.
Inviti
Un appuntamento che Lei ha organizzato compare nel file con Lei come ORGANIZER. Dopo l'importazione si trova nel Suo nuovo calendario, ma i partecipanti lo hanno ancora nel loro calendario come invito dal Suo vecchio indirizzo, con un UID del vecchio servizio. Se in seguito modifica l'appuntamento, riceveranno un nuovo invito. Per riunioni ricorrenti con soggetti esterni può essere più ordinato invitarli di nuovo dopo il passaggio. Gli appuntamenti per cui Lei è stato invitato vengono trasferiti come normali appuntamenti; le risposte all'organizzatore avvengono via email.
Esportare da Google
- Calendario: in Google Calendar, in Impostazioni, nella sezione Importa ed esporta, il pulsante Esporta. Riceverà un file zip con un file ics per ogni calendario di cui è proprietario. I calendari che altri condividono con Lei non sono inclusi; li esporta il proprietario, oppure li esporta singolarmente dalle impostazioni di quel calendario, se consentito.
- Contatti: in Google Contatti seleziona i contatti (o tutti), sceglie Esporta e poi il formato vCard. Google offre anche "Google CSV" e "Outlook CSV"; scelga vCard, che mantiene la struttura (più numeri di telefono, indirizzi, foto).
- Tutto in una volta: Google Takeout (takeout.google.com) fornisce il calendario come ics, i contatti come vcf (o csv) e Gmail come mbox, in file zip. Utile come backup dell'intero account.
I nomi dei menu cambiano di tanto in tanto; in caso di dubbio cerchi nella guida di Google "esportare calendario".
Esportare da Microsoft
- Calendario: nel classico Outlook per Windows può salvare un calendario come file iCalendar (Salva con nome, con scelta del periodo e "dettagli completi"). Scelga un periodo che vada sufficientemente indietro e avanti, e scelga dettagli completi, altrimenti esporta solo le informazioni libero/occupato. In Outlook sul web può pubblicare un calendario come link ICS e scaricare il file tramite quel link; disattivi poi di nuovo la pubblicazione.
- Contatti: Outlook sul web esporta i contatti come csv, non come vCard. Anche il classico Outlook esporta in blocco in csv; vCard è possibile lì solo per singolo contatto. Molti servizi CardDAV non riescono a importare direttamente un file csv. Due vie d'uscita: utilizzare lo strumento di migrazione del nuovo servizio (che recupera i contatti direttamente), oppure importare il csv in una rubrica di Thunderbird ed esportarlo da lì come vCard.
- Calendari condivisi e calendari di sale sono calendari dell'organizzazione. Li esporta l'amministratore, oppure li ricrea nel nuovo servizio.
Cosa non viene incluso o viene trattato diversamente nell'esportazione
| Elemento | Cosa succede |
|---|---|
| Allegati agli appuntamenti | solitamente non vengono inclusi; solo un link, o niente |
| Colori e categorie | talvolta come CATEGORIES, spesso no |
| Promemoria | a volte, a seconda del servizio |
| Link per videoconferenze (Teams, Meet) | restano come testo nell'appuntamento, ma non funzionano più dopo la disdetta |
| Gruppi di contatti o etichette | non sempre; controlli dopo l'importazione |
| Foto dei contatti | vengono incluse nel vCard, ma rendono il file voluminoso |
Contare prima di proseguire
Annoti prima dell'esportazione quanti contatti ha e, per alcuni calendari, quanti appuntamenti ci sono in un periodo fisso (per esempio novembre). Dopo l'importazione conti di nuovo. È il modo più rapido per accorgersi che manca qualcosa. Nell'esercizio di questa lezione farà contare e controllare i file dal programma.
Nella pratica: come si presenta presso un fornitore
In un Nextcloud WebOké sono presenti due strumenti di migrazione che recuperano direttamente i dati: WebOké Import Tool per Google (Drive, Foto, Calendario e Contatti) e Migrazione dati per OneDrive e Microsoft 365, con cui importa anche contatti e calendari dal Suo account Microsoft. Se il Suo calendario proviene da altrove, importa Lei stesso i file ics e vCard (lezione 5.3). Nextcloud legge vCard 3.0 e 4.0. Presso altri servizi europei esistono strumenti di importazione simili o un pulsante di importazione nel calendario e nella rubrica; i formati di file sono gli stessi ovunque.
Riepilogo
- I calendari si trasferiscono come ics (iCalendar), i contatti come vcf (vCard 3.0 o 4.0); sono file di testo leggibili.
- Uno strumento di migrazione che recupera direttamente i dati è spesso più semplice, ma crei comunque un'esportazione propria come controllo e backup.
- In un file ics presti attenzione a UID, RRULE e fusi orari con un blocco VTIMEZONE; senza di esso gli appuntamenti si spostano.
- Outlook sul web esporta i contatti solo come csv; utilizzi uno strumento di migrazione o converta il csv in vCard.
- Conti in anticipo contatti e appuntamenti, così dopo l'importazione potrà verificare se manca qualcosa.
Quiz
Esercizio
Esercizio A5.2: Controllare la Sua esportazione di prova. Esporti un calendario (ics) e i Suoi contatti (vcf). Inserisca prima quanti contatti ha e quanti appuntamenti si aspetta. Carichi poi i file. Il programma controlla se sono validi, conta appuntamenti, ricorrenze e contatti, cerca fusi orari senza descrizione e contatti duplicati, e confronta con i Suoi numeri. I file vengono solo letti e non conservati.
Esercizio E5.2: Cosa non viene trasferito? Apra il Suo file ics in un editor di testo. Cerchi un appuntamento ricorrente, un appuntamento con partecipanti e un appuntamento con un link per videoconferenza. Annoti per ciascun appuntamento cosa deve fare dopo il passaggio.
Esercizio E5.2: Cosa non viene trasferito?
Apra il Suo file ics in un editor di testo.
Le Sue spunte e note restano solo in questo browser; non le inviamo da nessuna parte. Se ha effettuato l'accesso, conserviamo in I miei corsi solo il fatto che ha svolto l'esercizio.
Per approfondire
I passaggi descritti in questi articoli valgono per i servizi di WebOké; presso altri fornitori il funzionamento è simile.
- Guida a Nextcloud 13.5: Trasferire calendario e contatti da Google, iCloud o Outlook (ics e vCard)
- Guida a Nextcloud 13.2: Trasferire Google Drive, Foto, Calendario e Contatti con WebOké Import Tool
- Guida a Nextcloud 13.4: Trasferire OneDrive con Migrazione dati
- Guida a Nextcloud 13.6: Da Microsoft 365 a WebOké: file, documenti, e-mail e calendario
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Guida Google Calendar: Esportare eventi; Guida Google Contatti: Esportare contatti; Supporto Microsoft: Esportare i contatti da Outlook
